#include <stdio.h>
#include "consumer.h"

void consumer_init(DOLProcess *p) 
{
	p->local->index = 0;
	p->local->len = LENGTH;
}

int consumer_fire(DOLProcess *p) {
	int i, j, k, l; 
	
	CREATEPORTVAR(prt);

	if (p->local->index < p->local->len) 
	{
		
	for(i = 0; i < DIM; i++)
		for(j = 0; j < DIM; j++)
			p->local->a[i][j] = 0;

		for(i = 0; i < NCUT; i++)
		{
			for(j = i; j < NCUT; j++)
			{
				CREATEPORT(prt, PORT_IN, 2, j, NCUT, i, NCUT);
				
				DOL_read((void*)prt, p->local->temp, N*N*sizeof(double), p);
				for(k = 0; k < N; k++)
				{
					for(l = 0; l < N; l++)
					{		
						p->local->a[k + j*N][l + i*N] = p->local->temp[k][l];
					}
				}
				
			}
		}
	
		printf("\nOutput:\n");
		for(i = 0; i < DIM; i++)
		{
			for(j = 0; j < DIM; j++)
			{
				printf("%.2f ",p->local->a[i][j]);
			}
			printf("\n");
		}
		p->local->index++;
	}
	if (p->local->index >= p->local->len) 
	{
		DOL_detach(p);
		return -1;
	}
	return 0;
}
